ALTER TABLE TodoItems RENAME TO oldTodoItems;
ALTER TABLE Places RENAME TO oldPlaces;
ALTER TABLE TodoItemPlaces RENAME TO oldTodoItemPlaces;
ALTER TABLE TodoPredecessors RENAME TO oldTodoPredecessors;
ALTER TABLE PlaceRelations RENAME TO oldPlaceRelations;
ALTER TABLE Notes RENAME TO oldNotes;
ALTER TABLE DeletedItems RENAME TO oldDeletedItems;
ALTER TABLE ViewIndexes RENAME TO oldViewIndexes;
ALTER TABLE Reminders RENAME TO oldReminders;
ALTER TABLE Bookmarks RENAME TO oldBookmarks;
ALTER TABLE Preferences RENAME TO oldPreferences;
ALTER TABLE NearbyReminders RENAME TO oldNearbyReminders;
ALTER TABLE TaskSort RENAME TO oldTaskSort;
ALTER TABLE TaskFilter RENAME TO oldTaskFilter;
ALTER TABLE View RENAME TO oldView;
CREATE TABLE TodoItems (TodoItemID INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,ParentItemID INTEGER,ItemIndex INTEGER NOT NULL,TaskCaption TEXT NOT NULL,IsComplete INTEGER,IsStarred INTEGER,StarredDateTime INTEGER,Importance INTEGER,Urgency INTEGER,HideInToDo INTEGER,HideInToDoThisTask INTEGER,GoalFor INTEGER,ScheduleType INTEGER,CompletionDateTime INTEGER,DueDateTime INTEGER,LeadTime INTEGER,EstimateMin INTEGER,EstimateMax INTEGER,RecType INTEGER,RecStartDate INTEGER,RecEndDate INTEGER,RecOccurrences INTEGER,RecInterval INTEGER,RecInstance INTEGER,RecDOWMask INTEGER,RecDayOfMonth INTEGER,RecMonthOfYear INTEGER,RecUseCompletionDate INTEGER,RecUncompleteSubtasks INTEGER,RecGeneratedCount INTEGER,CompleteInOrder INTEGER,Effort INTEGER,Satisfaction INTEGER,IsProject INTEGER,ProjectStatus INTEGER,ProjectCompletion INTEGER,TaskNoteID INTEGER,CreatedDate INTEGER NOT NULL,LastModified INTEGER,IsExpanded INTEGER,RecUncomplIfCompl INTEGER,RecHourDelta INTEGER,RecDNCCCopy INTEGER,RecRecurWSC INTEGER,TaskUID TEXT NOT NULL,Ver INTEGER NOT NULL,DependOper INTEGER,StartDateTime INTEGER,FlagID INTEGER);
CREATE TABLE TodoItemPlaces (TaskID INTEGER NOT NULL,PlaceID INTEGER NOT NULL,PRIMARY KEY (TaskID,PlaceID));
CREATE TABLE TodoPredecessors (TodoItemDID INTEGER NOT NULL,LinkedItemID INTEGER NOT NULL,PRIMARY KEY (TodoItemDID, LinkedItemID));
CREATE TABLE Places (ContextID INTEGER PRIMARY KEY NOT NULL,ContextCaption TEXT NOT NULL,ContextNoteID INTEGER,HideFromTodo INTEGER,HideFromItemProps INTEGER,OpenHours BLOB,ContextUID TEXT NOT NULL,Latitude REAL,Longitude REAL,Radius REAL,NotifyEntering INTEGER,NotifyExiting INTEGER,Ver INTEGER NOT NULL);
CREATE TABLE PlaceRelations (PlaceDID INTEGER NOT NULL,ParentPlaceID INTEGER NOT NULL,PRIMARY KEY (PlaceDID, ParentPlaceID));
CREATE TABLE Notes (NoteID INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,Note TEXT NOT NULL);
CREATE TABLE ViewIndexes (ViewID INTEGER NOT NULL,TodoItemID INTEGER NOT NULL,ItemIndex INTEGER NOT NULL,UID TEXT NOT NULL,Ver INTEGER NOT NULL,PRIMARY KEY (ViewID, TodoItemID));
CREATE TABLE Reminders (ReminderID INTEGER PRIMARY KEY NOT NULL,TodoItemId INTEGER NOT NULL,Reminder INTEGER NOT NULL,NextAlert INTEGER NOT NULL,AutoAlert INTEGER NOT NULL,AutoAlertDelta INTEGER NOT NULL,LimitAutoAlertCount INTEGER NOT NULL,MaxAutoAlertCount INTEGER NOT NULL,AutoAlertIndex INTEGER NOT NULL,ReminderState INTEGER NOT NULL,AlertAction INTEGER NOT NULL,Email TEXT,AudioFile TEXT);
CREATE TABLE DeletedItems (DeletedUID TEXT NOT NULL,ID INTEGER NOT NULL,ObjectType INTEGER NOT NULL,DeleteDate INTEGER NOT NULL,Ver INTEGER NOT NULL,PRIMARY KEY (DeletedUID,ObjectType));
CREATE TABLE Bookmarks  (TodoItemID INTEGER PRIMARY KEY NOT NULL);
CREATE TABLE Preferences (Key TEXT PRIMARY KEY NOT NULL,Value INTEGER);
CREATE TABLE NearbyReminders (ContextID TEXT PRIMARY KEY ON CONFLICT IGNORE NOT NULL);
CREATE TABLE TaskSort (SortId INTEGER primary key on conflict replace autoincrement not null, ViewId INTEGER, Collation1 INTEGER, Collation2 INTEGER, Collation3 INTEGER, Collation4 INTEGER, Direction INTEGER not null);
CREATE TABLE TaskFilter (FilterId INTEGER primary key on conflict replace autoincrement not null,ParentFilterGroupId INTEGER,FilterCriterion TEXT not null,FilterParams BLOB,isInverse INTEGER not null);
CREATE TABLE Views (ViewId INTEGER primary key on conflict replace autoincrement not null, ViewName TEXT, FilterId INTEGER, SortingId INTEGER, Grouping TEXT not null, Hierarchy INTEGER not null, IncludeParents INTEGER not null, IncludeChildren INTEGER not null, ProcessBranch INTEGER not null);
INSERT INTO TodoItems SELECT * FROM oldTodoItems;
INSERT INTO Places SELECT * FROM oldPlaces;
INSERT INTO TodoItemPlaces SELECT * FROM oldTodoItemPlaces;
INSERT INTO TodoPredecessors SELECT * FROM oldTodoPredecessors;
INSERT INTO PlaceRelations SELECT * FROM oldPlaceRelations;
INSERT INTO Notes SELECT * FROM oldNotes;
INSERT INTO DeletedItems SELECT * FROM oldDeletedItems;
INSERT INTO ViewIndexes SELECT * FROM oldViewIndexes;
INSERT INTO Reminders SELECT * FROM oldReminders;
INSERT INTO Bookmarks SELECT * FROM oldBookmarks;
INSERT INTO Preferences SELECT * FROM oldPreferences;
INSERT INTO NearbyReminders SELECT * FROM oldNearbyReminders;
INSERT INTO TaskSort SELECT * FROM oldTaskSort;
INSERT INTO TaskFilter SELECT * FROM oldTaskFilter;
INSERT INTO Views SELECT * FROM oldView;
DROP TABLE oldTodoItems;
DROP TABLE oldPlaces;
DROP TABLE oldTodoItemPlaces;
DROP TABLE oldTodoPredecessors;
DROP TABLE oldPlaceRelations;
DROP TABLE oldNotes;
DROP TABLE oldDeletedItems;
DROP TABLE oldViewIndexes;
DROP TABLE oldReminders;
DROP TABLE oldBookmarks;
DROP TABLE oldPreferences;
DROP TABLE oldNearbyReminders;
DROP TABLE oldTaskSort;
DROP TABLE oldTaskFilter;
DROP TABLE oldView;
UPDATE TodoItems SET CompletionDateTime = CAST(CompletionDateTime AS INTEGER), DueDateTime = CAST(DueDateTime AS INTEGER), EstimateMax = CAST(EstimateMax AS INTEGER), EstimateMin = CAST(EstimateMin AS INTEGER), RecStartDate = CAST(RecStartDate AS INTEGER), RecEndDate = CAST(RecEndDate AS INTEGER), CreatedDate = CAST(CreatedDate AS INTEGER), LastModified = CAST(LastModified AS INTEGER), RecHourDelta = CAST(RecHourDelta AS INTEGER), StartDateTime = CAST(StartDateTime AS INTEGER);
UPDATE DeletedItems SET DeleteDate = CAST(DeleteDate AS INTEGER);
UPDATE Reminders SET Reminder = CAST(Reminder AS INTEGER), NextAlert = CAST(NextAlert AS INTEGER), AutoAlertDelta = CAST(AutoAlertDelta AS INTEGER);
CREATE INDEX idx_TodoItemPlaces_TaskID on TodoItemPlaces(TaskID ASC);
CREATE INDEX idx_TodoItems_ParentID on TodoItems (ParentItemID);
CREATE INDEX idx_TodoPredecessors_TodoItemID on TodoPredecessors (TodoItemDID);